#define DIRECTINPUT_VERSION 0x0800

#include <dinput.h>
#include <d3d8.h>
#include <d3dx8.h>

#include "error.h"

extern LPDIRECTINPUT8 g_pDI;


HRESULT InitializeInput(LPDIRECT3DDEVICE8 pD3DDevice,HWND hWndMain,HINSTANCE hInstMain);

HRESULT ShutdownInput();

class CZenMouse
{
public:
	CZenMouse();
	~CZenMouse();

// Variables
public:
	
protected:
	LPDIRECTINPUTDEVICE8 m_pMouseDev;
	LPDIRECT3DSURFACE8 m_pCursorSurf;
	
	BOOL m_bInitialized;
	BOOL m_bShowCursor;

	DIMOUSESTATE m_MouseData;

	// The cursor position
	POINT m_Position;
// Functions
public:
	HRESULT Initialize(LPDIRECT3DDEVICE8 pD3DDevice,LPDIRECTINPUT8 pDI,HWND hWndMain);
	HRESULT Poll();

	POINT GetMousePos();
	BOOL IsButtonDown( int Button );

	// Handles the WM_SETCURSOR message
	BOOL HandleSetCursor();
	// Toggles cursor display
	void ShowCursor( BOOL bShow ){ m_bShowCursor = bShow; }
	// Sets the position of the cursor
	void SetCursorPosition( int x, int y );
	// Gets the position of the cursor
	void GetCursorPosition( int& x, int& y );
	// Moves the position of the cursor.
	void MoveCursor( int x, int y );
	// Update the cursor position 
	// based on mouse movement
	void UpdateCursorPos();
protected:

};

class CZenKeyboard
{
public:
	CZenKeyboard();
	~CZenKeyboard();

// Variables
public:

protected:
	LPDIRECTINPUTDEVICE8 m_pKeyDev;
	char m_KeyBuffer[256];

	BOOL m_bInitialized;

// Functions
public:
	HRESULT Initialize(LPDIRECT3DDEVICE8 pD3DDevice,LPDIRECTINPUT8 pDI,HWND hWndMain);

	BOOL IsKeyDown( int Key );
  BOOL IsAnyKeyDown();
protected:

};

extern CZenKeyboard g_Keyboard;
extern CZenMouse g_Mouse;
