#include <winsock2.h>
#include <queue>
#include <assert.h>

DWORD WINAPI ListenForGame(void*);

enum ePacketType { pckAttack=0, pckGameOver };

#pragma pack(1)

struct sAttack
{
  char amount;
};

struct Packet
{
  ePacketType type;
  union
  {
    sAttack attack;
    bool WinOrLose;
  } data;
};
#pragma pack()

class NetworkSystem
{
public:
  friend DWORD WINAPI ListenForGame(void*);
  void ListenForGame();
  bool BrowseForGame();
  bool FoundGame() { return foundgame; }

  void SendPacket( Packet* packet );
  void ReceivePackets();

  void Init();
  void Stop();
  std::queue<Packet> packets;
private:
  SOCKET s;
  sockaddr_in opponent;
  bool foundgame;
};

extern NetworkSystem gNetwork;