#include "sound.hpp"
#include "error.h"
#include <vector>

CSoundSystem gSound;

void CSoundSystem::PlayMusic()
{
  WIN32_FIND_DATA find;
  HANDLE hfind;
  std::vector<const char*> vec;

  DWORD code;

  char path[256];
  strcpy( path, "media\\mp3\\" );

  hfind=FindFirstFile( "media\\mp3\\*.mp3", &find );
  if (hfind != INVALID_HANDLE_VALUE) 
  {
    vec.push_back( find.cFileName );
    while( FindNextFile( hfind, &find ) )
    {
      vec.push_back( find.cFileName );
    }
    FindClose( hfind );
    int track=rand()%vec.size();
    strcat( path, vec[track] );
    music=BASS_StreamCreateFile( false, path, 0, 0, 0 );
    if( music != 0 )
    {
      BASS_StreamPlay( music, 0, true );
    }else{
      code=BASS_ErrorGetCode();
      if( code == 41 )
      {
        char msg[256];
        sprintf( msg, "%s is in an invalid mp3 format", path );
        SetError( msg );
      }
    }
  }
}

void CSoundSystem::Init(HWND win)
{
  /* Initialize output - default device, 44100hz, stereo, 16 bits */
  if (!BASS_Init(1,44100,0,win,NULL))
    SetError("couldn't start sound");

	if (BASS_GetVersion()!=MAKELONG(2,0))
    SetError("wrong bass version");

  BASS_SetConfig( BASS_CONFIG_GVOL_STREAM, 50 );
  BASS_SetVolume( 50 );

  samples=NULL;

  music=NULL;

  LoadSamples();
}

void CSoundSystem::Shutdown()
{
  if( samples )
  {
    for( int i=0; i<numsamples; i++ )
    {
      if( samples[i] )
        BASS_SampleFree( samples[i] );
    }
  }
  delete [] samples;
  BASS_Free();
}

void CSoundSystem::LoadSamples()
{
  numsamples=5;
  samples=new HSAMPLE[numsamples];
  for(int i=0; i<numsamples; i++)
  {
    samples[i]=NULL;
  }
  
  samples[lose]=BASS_SampleLoad(FALSE,"media\\wavs\\lose.wav",0,0,3,BASS_SAMPLE_OVER_POS);
  samples[win]=BASS_SampleLoad(FALSE,"media\\wavs\\win.wav",0,0,3,BASS_SAMPLE_OVER_POS);
  samples[attackstrong]=BASS_SampleLoad(FALSE,"media\\wavs\\attackstrong.wav",0,0,3,BASS_SAMPLE_OVER_POS);
  samples[attack]=BASS_SampleLoad(FALSE,"media\\wavs\\attack.wav",0,0,3,BASS_SAMPLE_OVER_POS);
  samples[clearblocks]=BASS_SampleLoad(FALSE,"media\\wavs\\clear.wav",0,0,3,BASS_SAMPLE_OVER_POS);
}

void CSoundSystem::PlaySample(int sample)
{
  BASS_SamplePlay( samples[sample] );
}